import java.util.Stack;

public class Heap1 extends Tree1 {
	private class CountHolder {
		int count = 1;
	}
	public Heap1 parent;
	public CountHolder holder;
	public Heap1(Data data) {
		super(data);
		holder = new CountHolder();
	}
	public void addChild(Tree1 tree) {
		super.addChild(tree);
		((Heap1) tree).parent = this;
		((Heap1) tree).holder = holder;
		holder.count++;
		heapifyUp((Heap1) tree);
	}
	public void addChildToEnd(Heap1 heap) {
		Stack<Integer> stack = new Stack<Integer>();
		for (int i = holder.count + 1; i != 1; i = i >> 1) {
			stack.push(i & 1);
		}
		addChildToEnd(heap, stack);
	}
	private void addChildToEnd(Heap1 heap, Stack<Integer> stack) {
		int position = stack.pop();
		if (stack.isEmpty()) {
			addChild(heap);
		} else {
			((Heap1) children.get(position)).addChildToEnd(heap, stack);
		}
	}
	private void heapifyUp(Heap1 start) {
		if (start.parent != null) {
			if (start.data.compareTo(start.parent.data) == 1) {
				Data temp = start.parent.data;
				start.parent.data = start.data;
				start.data = temp;
				heapifyUp(start.parent);
			}
		}
	}
}
