import java.util.Stack;

public class Heap2 extends Tree2 {
	private class CountHolder {
		int count = 1;
	}
	public Heap2 parent;
	public CountHolder holder;
	public Heap2(Data data) {
		super(data);
		holder = new CountHolder();
	}
	public void addChild(Tree2 tree) {
		super.addChild(tree);
		((Heap2) tree).parent = this;
		((Heap2) tree).holder = holder;
		holder.count++;
		heapifyUp((Heap2) tree);
	}
	public void addChildToEnd(Heap2 heap) {
		Stack<Integer> stack = new Stack<Integer>();
		for (int i = holder.count + 1; i != 1; i = i >> 1) {
			stack.push(i & 1);
		}
		addChildToEnd(heap, stack);
	}
	private void addChildToEnd(Heap2 heap, Stack<Integer> stack) {
		int position = stack.pop();
		if (stack.isEmpty()) {
			addChild(heap);
		} else {
			MyList<Tree2> pointer = children.tail;
			for (int i = 0; i < position; i++) {
				pointer = pointer.tail;
			}
			((Heap2) pointer.head).addChildToEnd(heap, stack);
		}
	}
	private void heapifyUp(Heap2 start) {
		if (start.parent != null) {
			if (start.data.compareTo(start.parent.data) == 1) {
				Data temp = start.parent.data;
				start.parent.data = start.data;
				start.data = temp;
				heapifyUp(start.parent);
			}
		}
	}
}
