class IntData extends Data {
	int i;
	IntData(int i) {
		this.i = i;
	}
	public int compareTo(Data data) {
		int i2 = ((IntData) data).i;
		return i < i2 ? -1 : i > i2 ? 1 : 0;
	}
}

class Printer implements Visitor {
	public void visit(Data data) {
		System.out.println(((IntData) data).i);
	}
}

public class Test {
	
	private static void testTree1() {
		System.out.println("// Test Tree1");
		Tree1 tree1 = new Tree1(new IntData(0));
		Tree1 child1 = new Tree1(new IntData(1));
		Tree1 child2 = new Tree1(new IntData(4));
		tree1.addChild(child1);
		tree1.addChild(child2);
		Tree1 grandchild1 = new Tree1(new IntData(2));
		Tree1 grandchild2 = new Tree1(new IntData(3));
		child1.addChild(grandchild1);
		child1.addChild(grandchild2);
		tree1.preorder(new Printer());
	}
	
	private static void testTree2() {
		System.out.println("// Test Tree2");
		Tree2 tree1 = new Tree2(new IntData(0));
		Tree2 child1 = new Tree2(new IntData(1));
		Tree2 child2 = new Tree2(new IntData(4));
		tree1.addChild(child1);
		tree1.addChild(child2);
		Tree2 grandchild1 = new Tree2(new IntData(2));
		Tree2 grandchild2 = new Tree2(new IntData(3));
		child1.addChild(grandchild1);
		child1.addChild(grandchild2);
		tree1.preorder(new Printer());
	}
	
	private static void testHeap1AddChild() {
		System.out.println("// Test Heap1 (addChild)");
		Heap1 tree1 = new Heap1(new IntData(0));
		Heap1 child1 = new Heap1(new IntData(1));
		Heap1 child2 = new Heap1(new IntData(4));
		tree1.addChild(child1);
		tree1.addChild(child2);
		Heap1 grandchild1 = new Heap1(new IntData(2));
		Heap1 grandchild2 = new Heap1(new IntData(3));
		child1.addChild(grandchild1);
		child1.addChild(grandchild2);
		tree1.preorder(new Printer());
	}
	
	private static void testHeap1AddChildToEnd() {
		System.out.println("// Test Heap1 (addChildToEnd)");
		Heap1 tree1 = new Heap1(new IntData(0));
		Heap1 child1 = new Heap1(new IntData(1));
		Heap1 child2 = new Heap1(new IntData(4));
		Heap1 grandchild1 = new Heap1(new IntData(2));
		Heap1 grandchild2 = new Heap1(new IntData(3));
		tree1.addChildToEnd(child1);
		tree1.addChildToEnd(child2);
		tree1.addChildToEnd(grandchild1);
		tree1.addChildToEnd(grandchild2);
		tree1.preorder(new Printer());
	}
	
	private static void testHeap2AddChild() {
		System.out.println("// Test Heap2 (addChild)");
		Heap2 tree1 = new Heap2(new IntData(0));
		Heap2 child1 = new Heap2(new IntData(1));
		Heap2 child2 = new Heap2(new IntData(4));
		tree1.addChild(child1);
		tree1.addChild(child2);
		Heap2 grandchild1 = new Heap2(new IntData(2));
		Heap2 grandchild2 = new Heap2(new IntData(3));
		child1.addChild(grandchild1);
		child1.addChild(grandchild2);
		tree1.preorder(new Printer());
	}
	
	private static void testHeap2AddChildToEnd() {
		System.out.println("// Test Heap2 (addChildToEnd)");
		Heap2 tree1 = new Heap2(new IntData(0));
		Heap2 child1 = new Heap2(new IntData(1));
		Heap2 child2 = new Heap2(new IntData(4));
		Heap2 grandchild1 = new Heap2(new IntData(2));
		Heap2 grandchild2 = new Heap2(new IntData(3));
		tree1.addChildToEnd(child1);
		tree1.addChildToEnd(child2);
		tree1.addChildToEnd(grandchild1);
		tree1.addChildToEnd(grandchild2);
		tree1.preorder(new Printer());
	}

	public static void main(String[] args) {
		testTree1();
		testTree2();
		testHeap1AddChild();
		testHeap1AddChildToEnd();
		testHeap2AddChild();
		testHeap2AddChildToEnd();
	}
}
